#include <stdio.h>
#include <unistd.h>
#include <sys/ioctl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <string.h>
#include "camac.h"
#include "k3922_reg.h"

#define SCL_N     1
#define SCL_SIZE 16
#define DMA
void main()
{
  int fd = open("/dev/cc0", O_RDWR), i;
  struct naf_data cc;
  unsigned int scaler[SCL_SIZE];
  bzero(&scaler,sizeof(scaler));
  ioctl(fd, CCIOC_SET_CRATE, 0);
#ifdef DMA
  cc.mode = QSCAN | WSIZE24;
  cc.naf  = NAFGEN(SCL_N,0,0);
  ioctl(fd, CCIOC_SETUP_DMA, &cc);
  i = read(fd, &scaler, SCL_SIZE*sizeof(int));
  printf("return code = %d\n", i);
#else
  cc.mode = SINGLE | WSIZE24;
  for (i = 0; i < SCL_SIZE; i++) {
    cc.naf  = NAFGEN(SCL_N,i,0);
    ioctl(fd, CCIOC_SINGLE, &cc);
    scaler[i] = cc.data;
  }
#endif
  for (i = 0; i < SCL_SIZE; i++) printf("%2d:%10d\n", i, scaler[i]);
  close(fd);
}
